//Copyright 2009 Chris Glasier

/* 
Release 1.0 - Basic configuration
Release 1.01 - Revisions
	
# 	Added sketchup.rb (thanks to Tomasz SCF)
#	Add new scene setup for new files
>>	Right aligned menu
# 	Rename layer
#	Excluded Layer0

Release 1.02 - Revisions

aspects = Properties to be saved, Layers, Components, Views and Styles

Use cgScenes left column to browse (1st click) and (2nd click) open scene and current aspect
Use cgScenes middle column to open aspects for current scene
Use cg Scenes middle column layer menu to sort layers by abc or visibility and to add and name new layer
Use cg Scenes middle column components menu to show or hide all current scene components (pending)
Use cgScenes right column to browse (1st click) and (2nd click) hide/show properties to save,layers and components, and change views and styles.

Use SU context menu to add, delete, rename or describe a scene
Use SU layers to rename or delete existing layer
Use SU layers to select layer colours
Use SU shadows toolbar

*/

/*

A device using nameset interface technology to create/edit/review Sketchup scenes
Follows standard nameset for later integration
*/

panelWidth = 230
panelHeight = 345
cellHeight = 20
columns 	= 3

midRowTop = 5
stripeCells = 1


aspectArray = new Array()
aspectArray.push(new Array("Properties","Property","true"))
aspectArray.push(new Array("Layers","Layer","true"))
aspectArray.push(new Array("Components","Component","true"))
//aspectArray.push(new Array("Collections","Collection","true"))
//aspectArray.push(new Array("Groupings","Grouping","true"))
aspectArray.push(new Array("Views","View","true"))
aspectArray.push(new Array("Styles","Style","true"))

viewsArray = new Array()
viewsArray.push(new Array("View","Top","true"))
viewsArray.push(new Array("View","Bottom","true"))
viewsArray.push(new Array("View","Front","true"))
viewsArray.push(new Array("View","Back","true"))
viewsArray.push(new Array("View","Left","true"))
viewsArray.push(new Array("View","Right","true"))
viewsArray.push(new Array("View","Isometric","true"))
viewsArray.push(new Array("View","ZoomExtents","true"))
viewsArray.push(new Array("View","Perspective","true"))

newScenes = new Array("3d","Ortho","Trade")


function start(){

window.location = "skp:sceneCount"  

if(count == 0 ){
list = newScenes
for(a=0; a<list.length; a++){

window.location = "skp:sceneScenesAdd@"+list[a]  }   }

sceneSet()
sceneFirst()
sceneRun()   }


function receiveSceneCount(x){
count = x    }

function sceneResize(){
panelWidth = document.body.clientWidth
panelHeight = document.body.clientHeight
cellWidth = Math.floor(panelWidth/columns)
rows = Math.floor(panelHeight/cellHeight)
sceneRun() 
eval("sceneRun"+sceneAspect)()
document.getElementById("stripe").style.width = stripeCells * cellWidth      }


function sceneSet(){

dialogSize()

scenePanelNames()

layerSort = "abc"
//componentSort = "show"  all show /hide not yet done

confirmPanel.style.display = "none"

sliderTops = new Array(0,0,0)

sceneAspect = "Properties"
sliderTops[1] = 0

theMenu = "Refresh"
setMenu()

commander = "Scenes"  }



function receiveFirstScene(x){
ind = x    }


function sceneFirst(){

window.location = "skp:firstScene"

//ind from receiveScenes

sliderTops[0] = ind

params = new Array(ind)
params = params.join(",")
window.location = "skp:selectedScene@"+params

   }


function sceneRun(){

devicePanel.innerHTML = ""

sceneSetDeviceHolder()
sceneStripe()
sceneColumnSliders()
scenePanelSizes()

sceneRunScenes()

sceneRunAspects()    }


function dialogSize(){

w = panelWidth+6
h = panelHeight+30

cellWidth = Math.floor(panelWidth/columns)
rows = Math.floor(panelHeight/cellHeight)

params = new Array(w,h)

params = params.join(",")
window.location = "skp:set_size@"+ params   }


function scenePanelNames(){
copyPanel = document.getElementById("copy")
namePanel = document.getElementById("name")
devicePanel = document.getElementById("device")
confirmPanel = document.getElementById("confirm")
menuPanel1 = document.getElementById("menu1")
menuPanel2 = document.getElementById("menu2")   }


function sceneSetDeviceHolder(){
obj = document.createElement("div")
devicePanel.appendChild(obj)
obj.id = "holder"
deviceHolder = document.getElementById("holder")
with(deviceHolder){
with(style){
top = 0
width = panelWidth
height = panelHeight   }  }  }


function sceneStripe(){
obj = document.createElement("div")
deviceHolder.appendChild(obj)
with(obj){
id  = "stripe"
with(style){
left = 0
top = midRowTop * cellHeight
width = stripeCells * cellWidth
height = cellHeight 
backgroundColor = "#ffffff"  } }  }


function sceneColumnSliders(){
bLeft = 0
for(a=0; a<columns; a++){
sceneColumnSlider() }  } 


function sceneColumnSlider(){
obj = document.createElement("div")
deviceHolder.appendChild(obj)
with(obj){
colNo = a
id  = "sc"+ colNo 
with(style){
theTop = midRowTop-eval(sliderTops[a])
top = theTop*cellHeight   }  }   }



function scenePanelSizes(){
with(namePanel){
with(style){
left 	= 0
top 	= 2 * cellHeight  } }

with(devicePanel){
with(style){
left = 0
top = 2 * cellHeight}}

with(confirmPanel){
innerHTML = "UPDATE"
with(style){
left = panelWidth-cellWidth
top = 0   
width = cellWidth  }}


with(menuPanel1){
with(style){
left = 0
top = 0 
width = panelWidth
height = cellHeight
backgroundColor="#cccccc"
padding = "5px"   }  }

with(menuPanel2){
with(style){
left = 0
top = cellHeight
width = panelWidth
height = cellHeight
backgroundColor="#cccccc"
padding = "5px"  }  } 

with(copyPanel){
innerHTML = "&copy;Chris Glasier 2008/9"
with(style){
left = 0
top = 0
width = panelWidth
color = "#bbbbbb"
textAlign= "right"  }  } 

//Sliders

bLeft = 0
for(a=0; a<columns; a++){
with(document.getElementById("sc"+a).style){
left = bLeft
width = bLeft * cellWidth   }
bLeft = bLeft += cellWidth    }   }



function receiveScenes(x){
scenesString = x    }

function sceneRunScenes(){

window.location = "skp:findScenes"
//from receiveScenes
list = scenesString.split(";")
sceneArray = new Array()

for(a=0; a<list.length; a++){

couplet = list[a].split(",")

thisName = couplet[0].split(" ")
thisName = thisName.join("_")

entry = new Array()
entry[0] = "Scenes"
entry[1] = thisName
entry[2] = "true"

sceneArray.push(entry)  } 

childNos = sceneArray
colNo = 0
sceneRunChildren()  }


function sceneRunAspects(){
childNos = aspectArray
colNo = 1
sceneRunChildren()  }


function receiveProperties(x){
propertiesString = x    }

function sceneRunProperties(){
window.location = "skp:findProperties"

// from receiveLayers
list = propertiesString.split(";")

propertiesArray = new Array()

for(a=0; a<list.length; a++){

couplet = list[a].split(",")
thisName = couplet[0].split(" ")
thisName = thisName.join("_")

entry = new Array()
entry[0] = "Property"
entry[1] = thisName
entry[2] = couplet[1]

propertiesArray.push(entry)  } 

childNos = propertiesArray
colNo = 2
sceneRunChildren() }


function receiveLayers(x){
layersString = x    }


function sceneRunLayers(){

window.location = "skp:findLayers"

// from receiveLayers
list = layersString.split(";")
list.sort()

if(layerSort == "vis"){
visArray = new Array()
invArray = new Array()

for(a=0; a<list.length; a++){
list[a]=list[a].split(",")

if(list[a][1] == "true") visArray.push(list[a].join(","))
else invArray.push(list[a].join(","))}
list = visArray.concat(invArray)   }

layersArray = new Array()

for(a=0; a<list.length; a++){

couplet = list[a].split(",")
thisName = couplet[0].split(" ")
thisName = thisName.join("_")

if(thisName == "Layer0") continue

entry = new Array()
entry[0] = "Layer"
entry[1] = thisName
entry[2] = couplet[1]
entry[3] = couplet[2]

layersArray.push(entry)  } 

//firstEntry = new Array("Layer","Layer0","true")
//layersArray.splice(0,0,firstEntry)

childNos = layersArray
colNo = 2
sceneRunChildren()  }

function receiveComponents(x){
componentsString = x    }


function sceneRunComponents(){

window.location = "skp:findComponents"

// from receiveComponents
list = componentsString.split(";")
list.sort()

componentsArray = new Array()

for(a=0; a<list.length; a++){

couplet = list[a].split(",")
thisName = couplet[0].split(" ")
thisName = thisName.join("_")

//if(componentSort == "show") couplet[1] = "false" //all show
//if(componentSort == "hide") couplet[1] = "true"  // all hide

entry = new Array()
entry[0] = "Component"
entry[1] = thisName
couplet[1]=="false"? entry[2] = "true" : entry[2] = "false"
entry[3] = couplet[2]

componentsArray.push(entry)  } 

childNos = componentsArray
colNo = 2
sceneRunChildren()   }


function receiveStyles(x){
stylesString = x    }


function receiveSceneStyle(y){
sceneStyle = y     }


function sceneRunStyles(){

window.location = "skp:sceneStyle"
stylesArray = new Array()

window.location = "skp:findStyles"

// from receiveLayers
list = stylesString.split(";")
list.sort()

for(a=0; a<list.length; a++){

couplet = list[a].split(",")

if(couplet[0] == sceneStyle) activeRow = a
sliderTops[2] = activeRow

thisName = couplet[0].split(" ")
thisName = thisName.join("_")

entry = new Array()
entry[0] = "Style"
entry[1] = thisName
entry[2] ="true"
entry[3] = couplet[1]
stylesArray.push(entry)  } 

childNos = stylesArray
colNo = 2
sceneRunChildren()

stripeCells = 3
document.getElementById("stripe").style.width = stripeCells * cellWidth 

sceneAdjustSlider()  }


function sceneRunViews(){
childNos = viewsArray
colNo = 2
sceneRunChildren()  }


//RUN OFF


function sceneRunChildren(){
document.getElementById("sc"+ colNo).innerHTML = ""
bTop = 0
for(c=0; c<childNos.length; c++){

genericName = childNos[c][0]
givenName = childNos[c][1]
childNos[c][2] == "false"? theClass = "off" : theClass = "on"
childNos[c][3] == undefined? cind = 0 : cind = childNos[c][3]
obj = document.createElement("div")
document.getElementById("sc"+ colNo).appendChild(obj)

with(obj){
id = new Array(genericName,colNo,c,cind)
innerHTML = givenName
title = id			//for testing
className = theClass 
with(style){
left = 0
top = bTop 
width = cellWidth
height = cellHeight   }   }
bTop+= cellHeight    }   }


function sceneAdjustSlider(){
slider = document.getElementById("sc"+ colNo)
startTop = slider.style.top.slice(0,-2)
cTop = activeRow-midRowTop
finishTop = -cTop*cellHeight
sceneSlideStop = setInterval(sceneSlide,5)   }


function sceneSlide(){
if(slider.style.pixelTop == finishTop) clearInterval(sceneSlideStop)
else{
startTop-finishTop > 0? x = -1 :x = 1
slider.style.pixelTop += x*5   }   }



function sceneMenu2List(){
menuPanel2.innerHTML = ""
list = menuList.split(",")
for(a=0; a<list.length; a++){
obj = document.createElement("a")
menuPanel2.appendChild(obj)
with(obj){
innerHTML = list[a]
className = "menu" }  }  }

//EVENTS

counter = 0

lastCell = undefined

function deviceDown(e){

// moves activeCell over stripe

thisCell = event.srcElement

if(thisCell.id == "holder") return

thisCell == lastCell? counter = 1 : counter = 0
lastCell = thisCell

sceneCellId = thisCell.id.split(",")
genericName = sceneCellId[0]
commander = genericName

colNo = sceneCellId[1]
activeRow = sceneCellId[2]
cind = sceneCellId[3]
sceneAdjustSlider() 

eval("scene"+colNo+"Down")()   }


function scene0Down(){
sliderTops[0] = activeRow

if(counter == 1){
params = activeRow
window.location = "skp:selectedScene@"+params

menuList = ""
sceneMenu2List()     

stripeCells = 2
document.getElementById("stripe").style.width = stripeCells * cellWidth

eval("sceneRun"+sceneAspect)()    }

else{

stripeCells = 1
document.getElementById("stripe").style.width = stripeCells * cellWidth

document.getElementById("sc"+2).innerHTML =""
 
menuList = "Again to confirm"

sceneMenu2List()
menuPanel2.style.textAlign = "left"   }  }


function scene1Down(){
sliderTops[1]= activeRow
sliderTops[2]= 0

document.getElementById("sc2").innerHTML = ""

stripeCells = 2
document.getElementById("stripe").style.width = stripeCells * cellWidth

document.getElementById("sc2").style.top = 0

sceneAspect = genericName

menuList = eval("scene"+sceneAspect+"List")

sceneMenu2List()
menuPanel2.style.textAlign = "center"

eval("sceneRun"+genericName)()    }


function scene2Down(){

sliderTops[2]= activeRow

stripeCells = 3
document.getElementById("stripe").style.width = stripeCells * cellWidth

menuList = ""
sceneMenu2List()  

eval("sceneTools"+genericName)()

stripeCells = document.getElementById("stripe").style.width = stripeCells * cellWidth }


function sceneToolsProperty(){

if(counter==1) sceneLayerToggle()
else{
menuList = "Again to toggle"
sceneMenu2List()
menuPanel2.style.textAlign = "right"   }  }


function sceneToolsLayer(){

if(counter==1) sceneLayerToggle()
else{
if(thisCell.contentEditable == "true") menuList = ""
else menuList = "Again to toggle"
sceneMenu2List()
menuPanel2.style.textAlign = "right"   }  }

function sceneToolsComponent(){
if(counter==1) sceneComponentToggle()
else{
menuList = "Again to toggle"
sceneMenu2List()
menuPanel2.style.textAlign = "right"
window.location = "skp:hiliteClear"
window.location = "skp:hiliteOn@"+cind  } }

function sceneToolsView(){
word = thisCell.innerHTML
window.location = "skp:view"+word 
sceneUpdater()   }

function sceneToolsStyle(){
window.location = "skp:useStyle@"+cind
sceneUpdater()  }


//MENUS AND UPDATER

function setMenu(){
list = theMenu.split(",")
for(a=0; a<list.length;a++){
obj = document.createElement("a")
menuPanel1.appendChild(obj)
with(obj){
innerHTML = list[a]
className = "menu" }    }    }

function menu1Down(e){
menuCell = event.srcElement
if(menuCell.id == "menu1") return
menuPanel2.innerHTML = ""
devicePanel.innerHTML = ""
menuName =  menuCell.innerHTML.split(" ").join("")
menuPanel = menuPanel1
try{
eval("sceneMenu1"+menuName)()   }
catch(e){}   }


function sceneMenu1Refresh(){
sceneFirst()
sceneRun() 
eval("sceneRun"+sceneAspect)()
document.getElementById("stripe").style.width = stripeCells * cellWidth      }


function menu2Down(e){

menuCell = event.srcElement
menuName =  menuCell.innerHTML.split(" ").join("")
menuPanel = menuPanel2

try{eval("scene"+commander+menuName)()   }
catch(e){  }  }




scenePropertiesList = "Properties to save"
sceneLayersList = "Abc,Visibility,Add"
sceneComponentsList = "Pending"
//sceneComponentsList = "Show_all,Hide_all"
sceneViewsList = "Orthogonal views"
sceneStylesList = "Styles in model"




function sceneLayersAbc(){
layerSort = "abc"
sceneMenu1Refresh() }

function sceneLayersVisibility(){
layerSort = "vis"
sceneMenu1Refresh() }

function sceneLayersAdd(){
window.location = "skp:sceneLayersAdd" 
sceneMenu1Refresh()
sceneLayerRename()  }

function sceneComponentsShow_all(){
componentSort = "show"
sceneMenu1Refresh() }

function sceneComponentsHide_all(){
componentSort = "hide"
sceneMenu1Refresh() }

function scenePropertyToggle(){
fileName = "scenePropertyToggle"+thisCell.innerHTML+thisCell.className
window.location = "skp:"+fileName
thisCell.className == "on"? cl = "off" : cl = "on"
thisCell.className = cl
sceneUpdater() }


function sceneLayerRename(){
newCell = document.getElementById("sc"+2).firstChild
with(newCell){
contentEditable = true
with(style){
cursor = "text"
border = "1px black solid"   }   }
sceneUpdater()          }


function sceneLayerToggle(){
fileName = "sceneLayerToggle"+thisCell.className
window.location = "skp:"+fileName+"@"+cind
thisCell.className == "on"? cl = "off" : cl = "on"
thisCell.className = cl
sceneUpdater() }


function sceneComponentToggle(){
fileName = "sceneComponentToggle"+thisCell.className
window.location = "skp:"+fileName+"@"+cind
thisCell.className == "on"? cl = "off" : cl = "on"
thisCell.className = cl
sceneUpdater()	 }


function sceneUpdater(){
confirmPanel.style.display ="block" 	}

//Updater is in confirm block

function confirmDown(e){

confirmPanel.style.display ="none"
window.location = "skp:sceneUpdate" 

coll = document.getElementById("sc2").childNodes
for(a=0; a<coll.length; a++){

if(coll(a).contentEditable == "true"){
coll(a).contentEditable = false
coll(a).style.borderWidth = 0
coll(a).style.cursor = "pointer"

newName = coll(a).innerHTML
newName = newName.charAt(0).toUpperCase()+newName.substr(1).toLowerCase()

//newName = newName.toUpperCase()

ind = coll(a).id.split(",")
ind = ind[3]

params = new Array(ind,newName)
params = params.join(",")

window.location = "skp:sceneLayerRename@"+params
sceneMenu1Refresh()   }}}